#-----------------------------------------------------------------------------
%{?!dist:	%define	dist	.ok}
%global		oname		jack
%global		__python	/usr/bin/python3

%global		gname	%{oname}user
%global		pagroup		pulse-rt

#-----------------------------------------------------------------------------
Name		:	jack2
Version		:	1.9.21
Release		:	14.4.0.0%{?dist}
Summary		:	The Jack Audio Connection Kit

Packager	:	Osukiss Project	<build-ok@osukiss.org>

License		:	LGPLv2+
URL		:	https://github.com/jackaudio/jack2/releases

Source0		:	%{name}-%{version}.tar.gz
Source1		:	%{name}-ok_addon.tar.gz
Patch0		:	%{name}-%{version}-py311-readmode.patch

#-----------------------------------------------------------------------------
#Mandatory BuildRequires
BuildRequires	:	alsa-lib
BuildRequires	:	dbus
BuildRequires	:	doxygen
BuildRequires	:	expat-devel
BuildRequires	:	gcc-c++
BuildRequires	:	libsamplerate
BuildRequires	:	libsndfile
BuildRequires	:	opus
BuildRequires	:	python3
BuildRequires	:	waf


#-----------------------------------------------------------------------------
%description
JACK is a low-latency audio server, written primarily for the Linux operating
system. It can connect a number of different applications to an audio device, as
well as allowing them to share audio between themselves. Its clients can run in
their own processes (i.e. as a normal application), or can they can run within a
JACK server (i.e. a "plugin").
 
JACK is different from other audio server efforts in that it has been designed
from the ground up to be suitable for professional audio work. This means that
it focuses on two key areas: synchronous execution of all clients, and low
latency operation.

#-----------------------------------------------------------------------------
%files
%defattr(-,root,root,-)
%doc ChangeLog.rst README.rst README_NETJACK2
%doc %{oname}-script.pa
%config(noreplace) %{_sysconfdir}/security/limits.d/*.conf
%{_bindir}/jackd
%{_bindir}/jackrec
%{_libdir}/lib%{oname}*.so*
%{_libdir}/%{oname}/%{oname}_*.so
%{_libdir}/%{oname}/inprocess.so
%{_libdir}/%{oname}/netmanager.so
%{_libdir}/%{oname}/profiler.so
%{_libdir}/%{oname}/audioadapter.so
%{_libdir}/%{oname}/netadapter.so
%{_mandir}/man1/%{oname}rec.1.gz

#============================================================================
%package		dbus
Summary		:	Jack D-Bus launcher

#-----------------------------------------------------------------------------
Requires	:	%{name}		= %{version}-%{release}
#-----------------------------------------------------------------------------
%description		dbus
Launcher to start Jack through D-Bus.
 
#-----------------------------------------------------------------------------
%files			dbus
%defattr(-,root,root,-)
%{_bindir}/%{oname}dbus
%{_bindir}/%{oname}_control

%{_datadir}/dbus-1/services/org.%{oname}audio.service

#============================================================================
%package		devel
Summary		:	Header files for Jack

#-----------------------------------------------------------------------------
Requires	:	%{name}		= %{version}-%{release}

#-----------------------------------------------------------------------------
%description		devel
Header files for the Jack Audio Connection Kit.

%files			devel
%defattr(-,root,root,-)
%doc reference/html/
%{_includedir}/%{oname}/*.h
%{_libdir}/lib%{oname}.so
%{_libdir}/lib%{oname}net.so
%{_libdir}/lib{%oname}server.so
%{_libdir}/pkgconfig/{%oname}.pc
 
#-----------------------------------------------------------------------------
%pre
getent group %gname > /dev/null || groupadd -r %gname

#============================================================================
%package		example-clients
Summary		:	Example clients that use Jack

#-----------------------------------------------------------------------------
Requires	:	%{name}		= %{version}-%{release}

#-----------------------------------------------------------------------------
%description		example-clients
Small example clients that use the Jack Audio Connection Kit.

%files			example-clients
%defattr(-,root,root,-)
%{_bindir}/alsa_in
%{_bindir}/alsa_out
%{_bindir}/%{oname}_alias
%{_bindir}/%{oname}_bufsize
%{_bindir}/%{oname}_connect
%{_bindir}/%{oname}_disconnect
%{_bindir}/%{oname}_cpu_load
%{_bindir}/%{oname}_evmon
%{_bindir}/%{oname}_freewheel
%{_bindir}/%{oname}_latent_client
%{_bindir}/%{oname}_load
%{_bindir}/%{oname}_unload
%{_bindir}/%{oname}_lsp
%{_bindir}/%{oname}_metro
%{_bindir}/%{oname}_midi_dump
%{_bindir}/%{oname}_midi_latency_test
%{_bindir}/%{oname}_midiseq
%{_bindir}/%{oname}_midisine
%{_bindir}/%{oname}_monitor_client
%{_bindir}/%{oname}_net_master
%{_bindir}/%{oname}_net_slave
%{_bindir}/%{oname}_property
%{_bindir}/%{oname}_samplerate
%{_bindir}/%{oname}_server_control
%{_bindir}/%{oname}_session_notify
%{_bindir}/%{oname}_showtime
%{_bindir}/%{oname}_simple_client
%{_bindir}/%{oname}_simple_session_client
%{_bindir}/%{oname}_thru
%{_bindir}/%{oname}_transport
%{_bindir}/%{oname}_wait
%{_bindir}/%{oname}_zombie

# tests
%{_bindir}/%{oname}_cpu
%{_bindir}/%{oname}_iodelay
%{_bindir}/%{oname}_multiple_metro
%{_bindir}/%{oname}_simdtests
%{_bindir}/%{oname}_test

%{_mandir}/man1/alsa_*.1.gz
%{_mandir}/man1/%{oname}_bufsize.1.gz
%{_mandir}/man1/%{oname}_connect.1.gz
%{_mandir}/man1/%{oname}_disconnect.1.gz
%{_mandir}/man1/%{oname}_freewheel*.1.gz
%{_mandir}/man1/%{oname}_load*.1.gz
%{_mandir}/man1/%{oname}_unload*.1.gz
%{_mandir}/man1/%{oname}_lsp.1.gz
%{_mandir}/man1/%{oname}_metro.1.gz
%{_mandir}/man1/%{oname}_monitor_client.1.gz
%{_mandir}/man1/%{oname}_netsource.1.gz
%{_mandir}/man1/%{oname}_property.1.gz
%{_mandir}/man1/%{oname}_samplerate.1.gz
%{_mandir}/man1/%{oname}_showtime.1.gz
%{_mandir}/man1/%{oname}_simple_client.1.gz
%{_mandir}/man1/%{oname}_transport.1.gz
%{_mandir}/man1/%{oname}_wait.1.gz 

%exclude %{_mandir}/man1/%{oname}_impulse_grabber.1.gz

#test
%{_mandir}/man1/jack_iodelay.1.gz
#============================================================================
%prep
%setup -q 
%patch0 -p1

tar xf %{SOURCE1}
#-----------------------------------------------------------------------------
%build
export PREFIX=%{_prefix}
%{__python} ./waf configure				\
	--mandir=%{_mandir}/man1			\
	--libdir=%{_libdir}				\
	--alsa						\
	--clients 256					\
	--dbus						\
	--db						\
	--classic					\
	--doxygen					\
	--ports-per-application=2048			\
	--systemd=no					\
	--example-tools=yes				\

%define _smp_mflags -j%(/usr/bin/getconf _NPROCESSORS_ONLN)
%{__python} ./waf build					\
	%{?_smp_mflags}					\
	-v

#-----------------------------------------------------------------------------
%clean
%{__rm} -rf %{buildroot}

#-----------------------------------------------------------------------------
#installing program
%install
%{__rm} -rf %{buildroot}


%{__python} ./waf					\
	--destdir=%{buildroot}				\
	install

# For compatibility with jack1
%{__mv}							\
	%{buildroot}%{_bindir}/jack_rec			\
	%{buildroot}%{_bindir}/jackrec

%{__mv} %{buildroot}%{_datadir}/jack-audio-connection-kit/reference .	

# install our limits to the /etc/security/limits.d
%{__mkdir_p}						\
	%{buildroot}%{_sysconfdir}/security/limits.d
%{__cp}							\
	%{name}-ok_addon/%{oname}-limit.conf		\
	%{buildroot}%{_sysconfdir}/security/limits.d/95-jack.conf

sed -i							\
  -e 's,@gname@,%gname,g; s,@pagroup@,%pagroup,g;'	\
  %{buildroot}%{_sysconfdir}/security/limits.d/95-jack.conf


# install pulseaudio script for jack (as documentation part)
install -p -m644					\
	%{name}-ok_addon/%{oname}-script.pa		\
	.

#removing manual needed on classic mode only
%{__rm} %{buildroot}%{_mandir}/man1/%{oname}d.1

#-----------------------------------------------------------------------------
%changelog
